podTemplate(

  containers: [
    containerTemplate(name: 'maven', image: 'maven:3-openjdk-11', command: 'sleep', args: '99d'),
    containerTemplate(name: 'golang', image: 'golang:1.16.5', command: 'sleep', args: '99d')
  ], 
  
  volumes: [
    persistentVolumeClaim(
      mountPath: "$MAVEN_REPOSITORY",
      claimName: "jenkins-cache-pvc",
      readOnly: false
    )
  ]
  

){

  node(POD_LABEL) {

    MAVEN_OPTS = """\
        -Dhttps.protocols=TLSv1.2 \
        -Dmaven.repo.local=$MAVEN_REPOSITORY \
        -Dorg.slf4j.simpleLogger.showDateTime=true \
        -Djava.awt.headless=true \
    """
    
    MAVEN_CLI_OPTS = """\
        --batch-mode \
        --errors \
        --fail-at-end \
        --show-version \
        --no-transfer-progress \
        -DinstallAtEnd=true \
        -DdeployAtEnd=true \
    """
    
    SONAR_USER_HOME = "$WORKSPACE/.sonar"  // Defines the location of the analysis task cache

    // DEPLOYMENT_NAME = "$CI_PROJECT_NAME"
    
    DEV_KUBECTL_CONTEXT = "cehd/mspoc/kubernetes-agents:dev-qa"
    QA_KUBECTL_CONTEXT = "cehd/mspoc/kubernetes-agents:dev-qa"
    PROD_KUBECTL_CONTEXT = "cehd/mspoc/kubernetes-agents:prod"
    
    // CONTAINER_SHA_IMAGE_TAG = "$CI_REGISTRY_IMAGE:$CI_COMMIT_SHA" // Define image tag only for DEV
    // CONTAINER_IMAGE_TAG = "$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG" // Define image tag for QA, PROD

    DEV_NAMESPACE = "mspoc-dev-ns" // Defines the location of the deployment
    DEV_HOST_NAME = "dev.mspoc.cibanco.app" // Define host to deploy
    DEV_TLS_SECRET_NAME = "mspoc-dev-tls" // Define tls certificate

    QA_NAMESPACE = "mspoc-qa-ns" // Defines the location of the deployment
    QA_HOST_NAME = "qa.mspoc.cibanco.app" // Define host to deploy
    QA_TLS_SECRET_NAME = "mspoc-qa-tls" // Define tls certificate


    stage('Get a Maven project') {
      git url: "https://gitlab.com/startup-devops/demos/jenkins/springboot-helloworld-tsk-svc.git", branch: "main"
      container('maven') {
        stage('Build a Maven project') {
          sh "ls -l"
          sh "mvn -version"
          echo "${MAVEN_REPOSITORY}"
          echo "${SONAR_USER_HOME}"
          echo "${MAVEN_OPTS}"
          echo "${MAVEN_CLI_OPTS}"
          sh "mvn ${MAVEN_OPTS} ${MAVEN_CLI_OPTS} package -Dmaven.test.skip=true"
        }
      }
    }


    stage('Get a Golang project') {
        // git url: 'https://github.com/hashicorp/terraform.git', branch: 'main'
        container('golang') {
            stage('Build a Go project') {
                echo "HelloWorld"
            }
        }
    }

  }

}